//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3FBBE77102CC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3FBBE77102CC.cm

//## begin module%3FBBE77102CC.cp preserve=no
//## end module%3FBBE77102CC.cp

//## Module: ClusterRegion%3FBBE77102CC; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/ClusterRegion.h

#ifndef CLUSTERREGION_H
#define CLUSTERREGION_H 1

//## begin module%3FBBE77102CC.additionalIncludes preserve=no
//## end module%3FBBE77102CC.additionalIncludes

//## begin module%3FBBE77102CC.includes preserve=yes
#include "xsTypes.h"
//## end module%3FBBE77102CC.includes

// Error
#include <XSUtil/Error/Error.h>
// WmapRegion
#include "WmapRegion.h"
//## begin module%3FBBE77102CC.declarations preserve=no
//## end module%3FBBE77102CC.declarations

//## begin module%3FBBE77102CC.additionalDeclarations preserve=yes
//## end module%3FBBE77102CC.additionalDeclarations


//## begin ClusterRegion%3FBBE82101BD.preface preserve=yes
//## end ClusterRegion%3FBBE82101BD.preface

//## Class: ClusterRegion%3FBBE82101BD
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class ClusterRegion : public WmapRegion  //## Inherits: <unnamed>%3FBBE83202E5
{
  //## begin ClusterRegion%3FBBE82101BD.initialDeclarations preserve=yes
  //## end ClusterRegion%3FBBE82101BD.initialDeclarations

  public:
    //## Class: ClusterRegionError%3FBCEA1E02CA
    //## Category: XSModel::Model::MixFunction%3F7461FF026E
    //## Subsystem: XSModel::Model::MixFunction%3F74624902C0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ClusterRegionError : public YellowAlert  //## Inherits: <unnamed>%3FBCEA390112
    {
      public:
        //## Constructors (specified)
          //## Operation: ClusterRegionError%3FBCEA890200
          ClusterRegionError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (specified)
      //## Operation: ClusterRegion%3FBBE8A5016A
      ClusterRegion (const string& fileName, int regionNumber, size_t spectrumNumber);

    //## Destructor (generated)
      virtual ~ClusterRegion();


    //## Other Operations (specified)
      //## Operation: NINST%3FCBC7610181
      static size_t NINST ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: optic%3FBCE8D403C2
      const std::pair<Real,Real> optic () const;

      //## Attribute: instrument%3FBCE90B00AE
      int instrument () const;

      //## Attribute: instrumentNames%3FBCF155013A
      static const std::vector<std::string>& instrumentNames ();

      //## Attribute: instMapSizes%4034D9410187
      static const IntegerArray& instMapSizes ();

      //## Attribute: center%40363CC7027B
      std::pair<Real,Real> center () const;

      //## Attribute: nPixInRegion%40363D5D0325
      int nPixInRegion () const;

      //## Attribute: regionNumber%4044B2460256
      int regionNumber () const;

      //## Attribute: spectrumNumber%4044B285015A
      size_t spectrumNumber () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::MixFunction::<unnamed>%4034D73600DB
      //## Role: ClusterRegion::instMapFractions%4034D739026F
      const RealArray& instMapFractions () const;

  public:
    // Additional Public Declarations
      //## begin ClusterRegion%3FBBE82101BD.public preserve=yes
      //## end ClusterRegion%3FBBE82101BD.public

  protected:

    //## Other Operations (specified)
      //## Operation: readSpecificKeys%3FBCCB7802B1
      virtual void readSpecificKeys ();

    // Additional Protected Declarations
      //## begin ClusterRegion%3FBBE82101BD.protected preserve=yes
      //## end ClusterRegion%3FBBE82101BD.protected

  private:

    //## Other Operations (specified)
      //## Operation: convertNameToInt%3FBCEF4103A8
      void convertNameToInt (const string& instrument);

      //## Operation: calcInstMapFractions%4034DAF801CE
      void calcInstMapFractions ();

    // Additional Private Declarations
      //## begin ClusterRegion%3FBBE82101BD.private preserve=yes
      //## end ClusterRegion%3FBBE82101BD.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ClusterRegion::optic%3FBCE8D403C2.attr preserve=no  public: std::pair<Real,Real> {U} 
      std::pair<Real,Real> m_optic;
      //## end ClusterRegion::optic%3FBCE8D403C2.attr

      //## begin ClusterRegion::instrument%3FBCE90B00AE.attr preserve=no  public: int {U} 
      int m_instrument;
      //## end ClusterRegion::instrument%3FBCE90B00AE.attr

      //## begin ClusterRegion::instrumentNames%3FBCF155013A.attr preserve=no  public: static std::vector<std::string> {U} 
      static std::vector<std::string> s_instrumentNames;
      //## end ClusterRegion::instrumentNames%3FBCF155013A.attr

      //## Attribute: NINST%3FCBC5D20032
      //## begin ClusterRegion::NINST%3FCBC5D20032.attr preserve=no  public: static size_t {UC} 4
      static const size_t s_NINST;
      //## end ClusterRegion::NINST%3FCBC5D20032.attr

      //## begin ClusterRegion::instMapSizes%4034D9410187.attr preserve=no  public: static IntegerArray {V} 
      static IntegerArray s_instMapSizes;
      //## end ClusterRegion::instMapSizes%4034D9410187.attr

      //## begin ClusterRegion::center%40363CC7027B.attr preserve=no  public: std::pair<Real,Real> {U} 
      std::pair<Real,Real> m_center;
      //## end ClusterRegion::center%40363CC7027B.attr

      //## begin ClusterRegion::nPixInRegion%40363D5D0325.attr preserve=no  public: int {U} 
      int m_nPixInRegion;
      //## end ClusterRegion::nPixInRegion%40363D5D0325.attr

      //## begin ClusterRegion::regionNumber%4044B2460256.attr preserve=no  public: int {U} 
      int m_regionNumber;
      //## end ClusterRegion::regionNumber%4044B2460256.attr

      //## begin ClusterRegion::spectrumNumber%4044B285015A.attr preserve=no  public: size_t {U} 
      size_t m_spectrumNumber;
      //## end ClusterRegion::spectrumNumber%4044B285015A.attr

    // Data Members for Associations

      //## Association: XSModel::Model::MixFunction::<unnamed>%4034D73600DB
      //## begin ClusterRegion::instMapFractions%4034D739026F.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_instMapFractions;
      //## end ClusterRegion::instMapFractions%4034D739026F.role

    // Additional Implementation Declarations
      //## begin ClusterRegion%3FBBE82101BD.implementation preserve=yes
      //## end ClusterRegion%3FBBE82101BD.implementation

};

//## begin ClusterRegion%3FBBE82101BD.postscript preserve=yes
//## end ClusterRegion%3FBBE82101BD.postscript

// Class ClusterRegion::ClusterRegionError 

// Class ClusterRegion 


//## Other Operations (inline)
inline size_t ClusterRegion::NINST ()
{
  //## begin ClusterRegion::NINST%3FCBC7610181.body preserve=yes
  return s_NINST;
  //## end ClusterRegion::NINST%3FCBC7610181.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const std::pair<Real,Real> ClusterRegion::optic () const
{
  //## begin ClusterRegion::optic%3FBCE8D403C2.get preserve=no
  return m_optic;
  //## end ClusterRegion::optic%3FBCE8D403C2.get
}

inline int ClusterRegion::instrument () const
{
  //## begin ClusterRegion::instrument%3FBCE90B00AE.get preserve=no
  return m_instrument;
  //## end ClusterRegion::instrument%3FBCE90B00AE.get
}

inline const std::vector<std::string>& ClusterRegion::instrumentNames ()
{
  //## begin ClusterRegion::instrumentNames%3FBCF155013A.get preserve=no
  return s_instrumentNames;
  //## end ClusterRegion::instrumentNames%3FBCF155013A.get
}

inline const IntegerArray& ClusterRegion::instMapSizes ()
{
  //## begin ClusterRegion::instMapSizes%4034D9410187.get preserve=no
  return s_instMapSizes;
  //## end ClusterRegion::instMapSizes%4034D9410187.get
}

inline std::pair<Real,Real> ClusterRegion::center () const
{
  //## begin ClusterRegion::center%40363CC7027B.get preserve=no
  return m_center;
  //## end ClusterRegion::center%40363CC7027B.get
}

inline int ClusterRegion::nPixInRegion () const
{
  //## begin ClusterRegion::nPixInRegion%40363D5D0325.get preserve=no
  return m_nPixInRegion;
  //## end ClusterRegion::nPixInRegion%40363D5D0325.get
}

inline int ClusterRegion::regionNumber () const
{
  //## begin ClusterRegion::regionNumber%4044B2460256.get preserve=no
  return m_regionNumber;
  //## end ClusterRegion::regionNumber%4044B2460256.get
}

inline size_t ClusterRegion::spectrumNumber () const
{
  //## begin ClusterRegion::spectrumNumber%4044B285015A.get preserve=no
  return m_spectrumNumber;
  //## end ClusterRegion::spectrumNumber%4044B285015A.get
}

//## Get and Set Operations for Associations (inline)

inline const RealArray& ClusterRegion::instMapFractions () const
{
  //## begin ClusterRegion::instMapFractions%4034D739026F.get preserve=no
  return m_instMapFractions;
  //## end ClusterRegion::instMapFractions%4034D739026F.get
}

//## begin module%3FBBE77102CC.epilog preserve=yes
//## end module%3FBBE77102CC.epilog


#endif
